diff --git a/drivers/scsi/scsi_scan.c b/drivers/scsi/scsi_scan.c
index 4833b8fe251b..9580982c5700 100644
--- a/drivers/scsi/scsi_scan.c
+++ b/drivers/scsi/scsi_scan.c
@@ -977,7 +977,7 @@ static int scsi_add_lun(struct scsi_device *sdev, unsigned char *inq_result,
 	if (inq_result[7] & 0x10)
 		sdev->sdtr = 1;
 
-	sdev_printk(KERN_NOTICE, sdev, "%s %.8s %.16s %.4s PQ: %d "
+	sdev_printk(KERN_INFO, sdev, "%s %.8s %.16s %.4s PQ: %d "
 			"ANSI: %d%s\n", scsi_device_type(sdev->type),
 			sdev->vendor, sdev->model, sdev->rev,
 			sdev->inq_periph_qual, inq_result[2] & 0x07,
diff --git a/drivers/scsi/sd.c b/drivers/scsi/sd.c
index 950d8c9fb884..ad7d931bbbc9 100644
--- a/drivers/scsi/sd.c
+++ b/drivers/scsi/sd.c
@@ -2447,7 +2447,7 @@ sd_spinup_disk(struct scsi_disk *sdkp)
 			 */
 			if (media_not_present(sdkp, &sshdr)) {
 				if (media_was_present)
-					sd_printk(KERN_NOTICE, sdkp,
+					sd_printk(KERN_INFO, sdkp,
 						  "Media removed, stopped polling\n");
 				return;
 			}
@@ -2495,7 +2495,7 @@ sd_spinup_disk(struct scsi_disk *sdkp)
 						0x11 : 1,
 				};
 
-				sd_printk(KERN_NOTICE, sdkp, "Spinning up disk...");
+				sd_printk(KERN_INFO, sdkp, "Spinning up disk...");
 				scsi_execute_cmd(sdkp->device, start_cmd,
 						 REQ_OP_DRV_IN, NULL, 0,
 						 SD_TIMEOUT, sdkp->max_retries,
@@ -2700,7 +2700,7 @@ static int read_capacity_16(struct scsi_disk *sdkp, struct scsi_device *sdp,
 	alignment = ((buffer[14] & 0x3f) << 8 | buffer[15]) * sector_size;
 	lim->alignment_offset = alignment;
 	if (alignment && sdkp->first_scan)
-		sd_printk(KERN_NOTICE, sdkp,
+		sd_printk(KERN_INFO, sdkp,
 			  "physical block alignment offset: %u\n", alignment);
 
 	if (buffer[14] & 0x80) { /* LBPME */
@@ -2835,7 +2835,7 @@ sd_read_capacity(struct scsi_disk *sdkp, struct queue_limits *lim,
 		if ((sizeof(sdkp->capacity) > 4) &&
 		    (sdkp->capacity > 0xffffffffULL)) {
 			int old_sector_size = sector_size;
-			sd_printk(KERN_NOTICE, sdkp, "Very big device. "
+			sd_printk(KERN_INFO, sdkp, "Very big device. "
 					"Trying to use READ CAPACITY(16).\n");
 			sector_size = read_capacity_16(sdkp, sdp, lim, buffer);
 			if (sector_size < 0) {
@@ -2923,13 +2923,13 @@ sd_print_capacity(struct scsi_disk *sdkp,
 	string_get_size(sdkp->capacity, sector_size,
 			STRING_UNITS_10, cap_str_10, sizeof(cap_str_10));
 
-	sd_printk(KERN_NOTICE, sdkp,
+	sd_printk(KERN_INFO, sdkp,
 		  "%llu %d-byte logical blocks: (%s/%s)\n",
 		  (unsigned long long)sdkp->capacity,
 		  sector_size, cap_str_10, cap_str_2);
 
 	if (sdkp->physical_block_size != sector_size)
-		sd_printk(KERN_NOTICE, sdkp,
+		sd_printk(KERN_INFO, sdkp,
 			  "%u-byte physical blocks\n",
 			  sdkp->physical_block_size);
 }
@@ -3003,7 +3003,7 @@ sd_read_write_protect_flag(struct scsi_disk *sdkp, unsigned char *buffer)
 		sdkp->write_prot = ((data.device_specific & 0x80) != 0);
 		set_disk_ro(sdkp->disk, sdkp->write_prot);
 		if (sdkp->first_scan || old_wp != sdkp->write_prot) {
-			sd_printk(KERN_NOTICE, sdkp, "Write Protect is %s\n",
+			sd_printk(KERN_INFO, sdkp, "Write Protect is %s\n",
 				  sdkp->write_prot ? "on" : "off");
 			sd_printk(KERN_DEBUG, sdkp, "Mode Sense: %4ph\n", buffer);
 		}
@@ -3154,7 +3154,7 @@ sd_read_cache_type(struct scsi_disk *sdkp, unsigned char *buffer)
 
 		if (sdkp->first_scan || old_wce != sdkp->WCE ||
 		    old_rcd != sdkp->RCD || old_dpofua != sdkp->DPOFUA)
-			sd_printk(KERN_NOTICE, sdkp,
+			sd_printk(KERN_INFO, sdkp,
 				  "Write cache: %s, read cache: %s, %s\n",
 				  sdkp->WCE ? "enabled" : "disabled",
 				  sdkp->RCD ? "disabled" : "enabled",
@@ -3415,11 +3415,11 @@ static void sd_read_block_characteristics(struct scsi_disk *sdkp,
 		return;
 
 	if (sdkp->device->type == TYPE_ZBC)
-		sd_printk(KERN_NOTICE, sdkp, "Host-managed zoned block device\n");
+		sd_printk(KERN_INFO, sdkp, "Host-managed zoned block device\n");
 	else if (sdkp->zoned == 1)
-		sd_printk(KERN_NOTICE, sdkp, "Host-aware SMR disk used as regular disk\n");
+		sd_printk(KERN_INFO, sdkp, "Host-aware SMR disk used as regular disk\n");
 	else if (sdkp->zoned == 2)
-		sd_printk(KERN_NOTICE, sdkp, "Drive-managed SMR disk\n");
+		sd_printk(KERN_INFO, sdkp, "Drive-managed SMR disk\n");
 }
 
 /**
@@ -3567,7 +3567,7 @@ static void sd_read_cpr(struct scsi_disk *sdkp)
 out:
 	disk_set_independent_access_ranges(sdkp->disk, iars);
 	if (nr_cpr && sdkp->nr_actuators != nr_cpr) {
-		sd_printk(KERN_NOTICE, sdkp,
+		sd_printk(KERN_INFO, sdkp,
 			  "%u concurrent positioning ranges\n", nr_cpr);
 		sdkp->nr_actuators = nr_cpr;
 	}
@@ -4025,10 +4025,10 @@ static int sd_probe(struct device *dev)
 	if (sdkp->security) {
 		sdkp->opal_dev = init_opal_dev(sdkp, &sd_sec_submit);
 		if (sdkp->opal_dev)
-			sd_printk(KERN_NOTICE, sdkp, "supports TCG Opal\n");
+			sd_printk(KERN_INFO, sdkp, "supports TCG Opal\n");
 	}
 
-	sd_printk(KERN_NOTICE, sdkp, "Attached SCSI %sdisk\n",
+	sd_printk(KERN_INFO, sdkp, "Attached SCSI %sdisk\n",
 		  sdp->removable ? "removable " : "");
 	scsi_autopm_put_device(sdp);
 
@@ -4166,7 +4166,7 @@ static void sd_shutdown(struct device *dev)
 		return;
 
 	if (sdkp->WCE && sdkp->media_present) {
-		sd_printk(KERN_NOTICE, sdkp, "Synchronizing SCSI cache\n");
+		sd_printk(KERN_INFO, sdkp, "Synchronizing SCSI cache\n");
 		sd_sync_cache(sdkp);
 	}
 
@@ -4174,7 +4174,7 @@ static void sd_shutdown(struct device *dev)
 	     sdkp->device->manage_system_start_stop) ||
 	    (system_state == SYSTEM_POWER_OFF &&
 	     sdkp->device->manage_shutdown)) {
-		sd_printk(KERN_NOTICE, sdkp, "Stopping disk\n");
+		sd_printk(KERN_INFO, sdkp, "Stopping disk\n");
 		sd_start_stop_device(sdkp, 0);
 	}
 }
@@ -4195,7 +4195,7 @@ static int sd_suspend_common(struct device *dev, bool runtime)
 
 	if (sdkp->WCE && sdkp->media_present) {
 		if (!sdkp->device->silence_suspend)
-			sd_printk(KERN_NOTICE, sdkp, "Synchronizing SCSI cache\n");
+			sd_printk(KERN_INFO, sdkp, "Synchronizing SCSI cache\n");
 		ret = sd_sync_cache(sdkp);
 		/* ignore OFFLINE device */
 		if (ret == -ENODEV)
@@ -4207,7 +4207,7 @@ static int sd_suspend_common(struct device *dev, bool runtime)
 
 	if (sd_do_start_stop(sdkp->device, runtime)) {
 		if (!sdkp->device->silence_suspend)
-			sd_printk(KERN_NOTICE, sdkp, "Stopping disk\n");
+			sd_printk(KERN_INFO, sdkp, "Stopping disk\n");
 		/* an error is not worth aborting a system sleep */
 		ret = sd_start_stop_device(sdkp, 0);
 		if (!runtime)
@@ -4237,7 +4237,7 @@ static int sd_resume(struct device *dev)
 {
 	struct scsi_disk *sdkp = dev_get_drvdata(dev);
 
-	sd_printk(KERN_NOTICE, sdkp, "Starting disk\n");
+	sd_printk(KERN_INFO, sdkp, "Starting disk\n");
 
 	if (opal_unlock_from_suspend(sdkp->opal_dev)) {
 		sd_printk(KERN_NOTICE, sdkp, "OPAL unlock failed\n");
@@ -4260,7 +4260,7 @@ static int sd_resume_common(struct device *dev, bool runtime)
 		return 0;
 	}
 
-	sd_printk(KERN_NOTICE, sdkp, "Starting disk\n");
+	sd_printk(KERN_INFO, sdkp, "Starting disk\n");
 	ret = sd_start_stop_device(sdkp, 1);
 	if (!ret) {
 		sd_resume(dev);